<template>
  <main>
    <v-container>
      <v-layout row>
        <v-flex sm12>
          <v-card>
            <v-card-title primary-title>
              <div>
                <div class="headline">Game Management</div>
                <div class="grey--text">Lorem ipsum dolor sit amet.</div>
              </div>
              <v-spacer />
              <v-text-field append-icon="search" label="Search" single-line hide-details v-model="search"></v-text-field>
              <create-game></create-game>
            </v-card-title>
            <!-- Card Content -->
            <v-data-table :headers="headers" :items="items" :search="search" :loading="loading" :rows-per-page-items="[50, 100, 500]">
              <template slot="items" scope="props">
                <tr @click="game(props.item.id)">
                  <td>{{$store.state.gameTypes.find(game => (game.value === props.item.game_type)).text}}</td>
                  <td>{{props.item.is_team}}</td>
                  <td>{{props.item.status}}</td>
                </tr>
              </template>
            </v-data-table>
          </v-card>
        </v-flex>
      </v-layout>
    </v-container>
  </main>
</template>

<script>
  import CreateGame from '@/components/create-game'
  export default {
    name: 'games',
    components: {CreateGame},
    data () {
      return {
        loading: true,
        search: null,
        headers: [
          { text: 'Game Type', value: 'type', align: 'left' },
          { text: 'Team Game', value: 'is_team', align: 'left' },
          { text: 'Status', value: 'status', align: 'left' }
        ],
        items: [],
        db: this.$database.ref('game_details')
      }
    },
    methods: {
      game (id) { this.$router.push({path: `game/${id}`}) },
      loadGames (ref) {
        ref.once('value').then(snapshot => {
          let game = snapshot.val()

          if (game) {
            Object.keys(game).forEach(gameId => {
              game[gameId].id = gameId
              this.items.push(game[gameId])
            })
          }

          this.loading = false
        })
      }
    },
    created () {
      /*
       * You can extend this with queries
       * https://firebase.google.com/docs/database/web/lists-of-data#sorting_and_filtering_data
       * Example: this.db.orderByChild('propName')
       */
      let ref = this.db
      this.loadGames(ref)
    }
  }
</script>

<style scoped>
  td:hover { cursor: pointer; }
</style>
